#include<iostream>
#include<string>
#include<vector>
#include<set>
#include<deque>

using namespace std;

typedef long long ll;

vector<int> max_from_right(ll i, vector<int>& h) {
    vector<int>prefh(h.size() - i, h[i]);
    for (ll ii = i + 1; ii < h.size(); ++ii) {
        prefh[ii - i] = max(prefh[ii - i], prefh[ii - i - 1]);
        prefh[ii - i] = max(prefh[ii - i], h[ii]);
    }
    return prefh;
}

vector<int> max_from_left(ll i, vector<int>& h) {
    vector<int>prefh(i + 1, h[i]);
    for (ll ii = i - 1; ii << h.size() >= 0; --ii) {
        prefh[ii] = max(prefh[ii], prefh[ii + 1]);
        prefh[ii] = max(prefh[ii], h[ii]);
    }
    return prefh;
}

void qwe(set<vector<ll>>& blocks, deque<vector<ll>>& blocks1) {
    while (blocks1.size()) {
        auto el = blocks1.front();
        blocks.insert(el);
        blocks1.pop_front();
    }
}

void sol2() {
    int n; cin >> n;
    vector<int>h(n);
    set<vector<ll>> blocks;
    deque<vector<ll>>blocks1;

    int mh = -1;
    for (ll i = 0;i < n;++i) {
        cin >> h[i];
        mh = max(mh, h[i]);
        blocks1.push_back({ i, i, 0 });
    }
    if (n <= 1000) {
        qwe(blocks, blocks1);
        ll q = n - 1;
        for (ll _ = 0; _ < q; ++_) {
            ll j; cin >> j;
            --j;
            auto it = blocks.begin(), it2 = blocks.begin();
            for (ll i = 0; i < j; ++i) {
                it++; it2++;
            }
            it2++;
            long long ans = 0;
            ll st = (*it)[0], fn = (*it2)[1];
            for (ll i = st + 1; i < fn; ++i) {
                int rh = -1, lh = 0;
                for (ll ii = i + 1; ii <= fn; ++ii) {
                    if (h[ii] > h[i]) {
                        rh = max(h[ii], rh);
                    }
                }
                if (rh == -1) rh = h[i];
                for (ll ii = i - 1; ii >= st; --ii) {
                    if (h[ii] > h[i]) {
                        lh = max(h[ii], lh);
                    }
                }
                if (lh == -1) lh = h[i];
                ll ht = min(rh, lh);
                ans += max(ll(0), ht - h[i]);
            }
            cout << ans << '\n';
            blocks.insert({ st, fn, ans });
            blocks.erase(it);
            blocks.erase(it2);
        }
    }
    else {
        vector<vector<int>> pref(n);
        for (ll i = 0; i < n; ++i) {
            for (int el : max_from_left(i, h)) pref[i].push_back(el);
            pref[i].pop_back();
            for (int el : max_from_right(i, h)) pref[i].push_back(el);
        }
        int q = n - 1;
        bool fl = false, x = true, y = false;
        int a = 0, fi = -1;
        for (int _ = 0; _ < q; ++_) {
            int j; cin >> j;
            --j;
            if (j) x = false;
            ll ans = 0;
            int st, fn;
            auto it = blocks.begin(), it2 = blocks.begin();
            if (!x) {
                qwe(blocks, blocks1);
                
                for (int i = 0; i < j; ++i) {
                    it++; it2++;
                }
                it2++;
                st = (*it)[0]; fn = (*it2)[1];
                if (h[(*it)[1]] >= pref[fn][(*it2)[1]]) {
                    ans += (*it)[2];
                    st = (*it)[1];
                }
                if (h[(*it2)[0]] >= pref[st][(*it)[1]]) {
                    ans += (*it2)[2];
                    fn = (*it2)[0];
                }
            }
            else {
                auto cur = blocks1.front(); blocks1.pop_front();
                st = 0; fn = blocks1.front()[1];
                if (h[0] <= h[1]) {
                    fl = 1;
                }
                if (fl && x && y) {
                    ans += a;
                    st = fi;
                }
                else if (fl && x && !y) {
                    for (int i = 0; i < blocks1.front()[0]; ++i) {
                        int ht = min(pref[i][st], pref[i][fn]);
                        ans += max(0, ht - h[i]);
                    }
                    a = ans;
                    y = 1;
                    fi = blocks1.front()[0];
                }
            }
            
            for (int i = st + 1; i < fn; ++i) {
                int ht = min(pref[i][st], pref[i][fn]);
                ans += max(0, ht - h[i]);
            }

            cout << ans << '\n';
            if (!x) {
                blocks.insert({ st, fn, ans });
                blocks.erase(it);
                blocks.erase(it2);
            }
            else {
                blocks1.push_front({ fi, fn, ans });
            }
        }
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    sol2();
    return 0;
}