#include<iostream>
#include<string>
#include<vector>
#include<set>

using namespace std;

typedef long long ll;

void sol() {
	string l, r; cin >> l >> r;
	if (r.size() <= 18) {
		ll a, b; a = stoll(l); b = stoll(r);
		//vector<ll>is_prime(b + 1, 1);
		//for (ll i = 2; i < b; ++i) {
		//	if (is_prime[b]) {
		//		for (ll j = i + i; j < b; j += i) is_prime[j] = 0;
		//	}
		//}
		ll cnt = 0;
		for (ll i = a; i <= b; ++i) {
			//if (!is_prime[i]) continue;
			ll k = 1, i1 = i;
			while (i1) {
				k *= i1 % 10;
				i1 /= 10;
			}
			if (k < 2) continue;
			bool flag = 1;
			for (ll j = 2; j * j <= k; ++j) {
				if (k % j == 0) {
					flag = false;
					break;
				}
			}
			if (flag) {
				cnt++;
			}
		}
		cout << cnt;
	}
}

vector<int> max_from_right(ll i, vector<int>& h) {
	vector<int>prefh(h.size() - i, h[i]);
	for (ll ii = i + 1; ii < h.size(); ++ii) {
		prefh[ii - i] = max(prefh[ii - i], prefh[ii - i - 1]);
		prefh[ii - i] = max(prefh[ii - i], h[ii]);
	}
	return prefh;
}

vector<int> max_from_left(ll i, vector<int>& h) {
	vector<int>prefh(i + 1, h[i]);
	for (ll ii = i - 1; ii << h.size() >= 0; --ii) {
		prefh[ii] = max(prefh[ii], prefh[ii + 1]);
		prefh[ii] = max(prefh[ii], h[ii]);
	}
	return prefh;
}

vector<short> max_from_right_s(ll i, vector<int>& h) {
	vector<short>prefh(h.size() - i, h[i]);
	for (ll ii = i + 1; ii < h.size(); ++ii) {
		prefh[ii - i] = max(prefh[ii - i], prefh[ii - i - 1]);
		prefh[ii - i] = max(prefh[ii - i], short(h[ii]));
	}
	return prefh;
}

vector<short> max_from_left_s(ll i, vector<int>& h) {
	vector<short>prefh(i + 1, h[i]);
	for (ll ii = i - 1; ii << h.size() >= 0; --ii) {
		prefh[ii] = max(prefh[ii], prefh[ii + 1]);
		prefh[ii] = max(prefh[ii], short(h[ii]));
	}
	return prefh;
}

void sol2() {
	int n; cin >> n;
	vector<int>h(n);
	set<pair<ll, ll>> blocks;
	int mh = -1;
	for (ll i = 0;i < n;++i) {
		cin >> h[i];
		mh = max(mh, h[i]);
		blocks.insert(make_pair(i, i));
	}
	if (n <= 1000) {
		ll q = n - 1;
		for (ll _ = 0; _ < q; ++_) {
			ll j; cin >> j;
			--j;
			auto it = blocks.begin(), it2 = blocks.begin();
			for (ll i = 0; i < j; ++i) {
				it++; it2++;
			}
			it2++;
			long long ans = 0;
			ll st = (*it).first, fn = (*it2).second;
			for (ll i = st + 1; i < fn; ++i) {
				int rh = -1, lh = 0;
				for (ll ii = i + 1; ii <= fn; ++ii) {
					if (h[ii] > h[i]) {
						rh = max(h[ii], rh);
					}
				}
				if (rh == -1) rh = h[i];
				for (ll ii = i - 1; ii >= st; --ii) {
					if (h[ii] > h[i]) {
						lh = max(h[ii], lh);
					}
				}
				if (lh == -1) lh = h[i];
				ll ht = min(rh, lh);
				ans += max(ll(0), ht - h[i]);
			}
			cout << ans << '\n';
			blocks.insert(make_pair(st, fn));
			blocks.erase(it);
			blocks.erase(it2);
		}
	}
	else if (mh <= 10){
		vector<vector<short>> pref(n);
		for (ll i = 0; i < n; ++i) {
			for (short el : max_from_left(i, h)) pref[i].push_back(el);
			pref[i].pop_back();
			for (short el : max_from_right(i, h)) pref[i].push_back(el);
		}
		int q = n - 1;
		for (int _ = 0; _ < q; ++_) {
			int j; cin >> j;
			--j;
			auto it = blocks.begin(), it2 = blocks.begin();
			for (int i = 0; i < j; ++i) {
				it++; it2++;
			}
			it2++;
			long long ans = 0;
			int st = (*it).first, fn = (*it2).second;
			for (int i = st + 1; i < fn; ++i) {
				int ht = min(pref[i][st], pref[i][fn]);
				ans += max(0, ht - h[i]);
			}
			cout << ans << '\n';
			blocks.insert(make_pair(st, fn));
			blocks.erase(it);
			blocks.erase(it2);
		}
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	sol2();
	return 0;
}