#include<iostream>
#include<vector>
#include<cmath>

using namespace std;

typedef long long ll;

void stup(ll d, ll l, ll r) {
	ll a = ll(sqrt(l)), b = ll(sqrt(r));
	ll lb = a, rb = b + 1;
	while (rb - lb > 1) {
		ll mid = (rb + lb) / 2;
		if (mid * mid > d) rb = mid;
		else lb = mid;
	}
	ll start = (lb * lb > d ? lb : rb), ans = 0;
	for (ll i = start; i <= b; ++i) {
		ll y2 = i * i - d;
		ll cnt = 0;
		bool flag = 1;
		ll t = ll(sqrt(y2));
		if (t * t == y2) {
			ans++;
		}
	}
	cout << ans;
}

void sol() {
	ll d, l, r; cin >> d >> l >> r;
	if (r <= 1e10) {
		stup(d, l, r);
		return;
	}
	ll a = ll(sqrt(l)), b = ll(sqrt(r)), cnt = 0;
	for (ll i = 2; i * i <= d; ++i) {
		if (d % i == 0) {
			ll a1 = i, b1 = d / i;
			if ((a1 + b1) % 2 != 0 || (b1 - a1) % 2 != 0) continue;
			ll x = (a1 + b1) / 2, y = (b1 - a1) / 2;
			if (x >= a && x <= b && y >= a && y <= b) ++cnt;
		}
	}
	cout << cnt;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	sol();
	return 0;
}