#include<iostream>
#include<vector>
#include<cmath>
#include<set>

using namespace std;

typedef long long ll;

void sol() {
    ll n, k; cin >> n >> k;
    vector<ll> a(n), pref(n + 1, 0);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
        pref[i + 1] = a[i] + pref[i];
    }
    ll mx = n - k + 1;
    ll sm = 0;
    if (k == 2) {
        cout << max(pref[n] - 2 * a[n - 1], pref[n] - 2 * a[0]);
        return;
    }
    if (k == 3) {
        set<pair<ll, ll>> ps;
        for (ll i = 0; i < n; ++i) {
            ps.insert({ a[i], i });
        }
        ll ans = 0;
        for (auto p : ps) {
            ll mn = p.first, mi = p.second;
            if (mi != 0 && mi != n - 1) {
                ans = max(ans, max(pref[mi] - mn, pref[n] - pref[mi + 1] - mn));
            }
            else if (mi == 0) {
                ans = max(ans, max(pref[n] - mn - pref[2], pref[n - 1] - 2 * mn));
            }
            else ans = max(ans, max(pref[n - 2] - mn, pref[n - 1] - mn - a[0]));
        }
        cout << ans;
        return;
    }
    vector<ll>ind;
    if (k == 2) {
        cout << max(pref[n] - 2 * a[n - 1], pref[n] - 2 * a[0]);
        return;
    }
    for (ll i = 0; i < n - mx + 1; ++i) {
        if (sm < pref[i + mx] - pref[i]) {
            ind.push_back(i);
            sm = pref[i + mx] - pref[i];
        }
    }
    ll mn = 1e9 + 1;
    for (ll ii : ind) {
        for (ll i = 0; i < ii; ++i) if (a[i] < mn) mn = a[i];
        for (ll i = ii + mx; i < n; ++i) if (a[i] < mn) mn = a[i];
    }
    cout << sm - mn;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    sol();
    return 0;
}