#include<iostream>
#include<vector>
#include<cmath>

using namespace std;

typedef long long ll;

void st4(ll sm, ll s, ll n) {
    if (sm != s) {
        cout << "No"; return;
    }
    cout << "Yes\n";
    for (ll i = 0;i < n;++i) {
        cout << 1 << '\n' << 1 << '\n';
    }
}

void st1(vector<ll>& a, ll s) {
    vector<vector<ll>> kk(a.size() + 1, vector<ll>(s + 1));
    for (ll i = 0; i <= a.size();++i) kk[i][0] = 1;
    for (ll i = 1; i <= a.size(); ++i) {
        for (ll w = 0; w <= s; ++w) {
            kk[i][w] |= kk[i - 1][w];
            if (w >= a[i - 1]) kk[i][w] |= kk[i - 1][w - a[i - 1]];
        }
    }
    if (kk[a.size()][s] == 0) {
        cout << "No"; return;
    }
    cout << "Yes\n";
    vector<ll> ans;
    ll w = s, i = a.size();
    while (w || i) {
        if (kk[i - 1][w]) {
            --i;
        }
        else {
            ans.push_back(i);
            w -= a[i - 1];
            i--;
        }
    }
    cout << ans.size() << '\n';
    reverse(ans.begin(), ans.end());
    for (ll i : ans) {
        cout << i << ' ';
    }
}

short check(vector<vector<ll>>&a, ll s) {
    if (a.size() != 2 || s != 4)
        return 0;
    if (a[0].size() != 1 || a[0][0] != 2) return 0;
    if (a[1].size() != 2 || a[1][1] != 1) return 0;
    return short(a[1][0] == 2) + 1;
}

void sol() {
    ll n, s; cin >> n >> s;
    bool flag = 1;
    vector<vector<ll>> a(n);
    ll sm = 0;
    for (ll i = 0; i < n; ++i) {
        ll ki; cin >> ki;
        if (ki != 1) flag = 0;
        a[i].resize(ki);
        for (ll j = 0; j < ki; ++j) {
            cin >> a[i][j];
            if (flag) sm += a[i][j];
        }
    }
    short fl = check(a, s);
    if (fl == 1) {
        cout << "No"; return;
    }
    if (fl == 2) {
        cout << "Yes\n";
        for (ll i = 0; i < 4; ++i) cout << 1 << '\n';
    }
    if (flag) {
        st4(sm, s, n);
        return;
    }
    if (n == 1) {
        st1(a[0], s);
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    sol();
    return 0;
}